<?php

unset($_GET);

//check if valid session
$newTarget = '/app/berogui/index.php?m=Sip';
require_once('/usr/local/www/berogui/includes/session.php');
unset($newTarget);

require_once("/usr/local/www/berogui/misc/config_parameter.php");
require_once("/usr/local/www/berogui/includes/Helper/HelperSip.php");
require_once("/usr/local/www/berogui/includes/Helper/Helper.php");
require_once('/usr/php/include/rootHelper.class.php');

require_once('/usr/php/include/CloudSbcApi.php');

$exec_ajax = 1;
$invalid = array();

// TODO: enhance validation

if (!$exec_ajax) {
	echo "<script>window.location='../../index.php?m=Sip&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
	exit(1);
}

chdir("../..");

// get databases
include "./includes/variables.php";
include_once("/usr/www/include/SQLite2ToSQLite3.php");
include "./misc/database.php";
$ba = new beroAri();
$bc = new beroConf('root');
$sbcConf = parse_ini_file('/etc/beroNet/sbc.conf');

// get vars
$name 		= $_POST['name'];
$pub_ip 	= $sbcConf['SBCVM_IP'];
$teams_cert = $_POST['teams_cert_options'];
$paired_id 	= $_POST['teams_opt_peer'];

// get default fqdn to enable skip if set
$fqdn = $bc->get('root', 'teams_fqdn');

### functions ###
function getCertificateSubject($path) {
	// get last part of subject from certificate aka fqdn
	$subject = '';
	rootHelper::system(true, "openssl x509 -noout -subject -in " . $path, $subject);
	return end(preg_split('/ /', $subject));
}

function validateCertificates($list) {
	// check crt and key with md5
	$regex 	= '/^\(stdin\)= (?<md5>.*)$/';
	$keymd5 = exec("/usr/local/bin/openssl rsa -noout -modulus -in ".$list['privkey']." | /usr/local/bin/openssl md5");
	$crtmd5 = exec("/usr/local/bin/openssl x509 -noout -modulus -in ".$list['cert']." | /usr/local/bin/openssl md5");
	if (preg_match($regex, $keymd5, $keymatched) && preg_match($regex, $crtmd5, $crtmatched) && $keymatched['md5'] === $crtmatched['md5']) {
		// check crt and cacert.pem match
		$verify = exec("/usr/local/bin/openssl verify -verbose -CAfile ".$list['chain']." ".$list['crt']);
		return(preg_match('/^.*: OK$/', $verify) || $verify == 'OK');
	}
	return false;
}

function moveCertificates($from, $to, &$error) {
	$cmds = array(
		"/bin/cat ".$from."/privkey.pem ".$from."/cert.pem > ".$to."/agent.pem", // combine key and crt && move
		"/bin/cat ".$from."/chain.pem > ".$to."/cafile.pem", // move cafile
		"/bin/chmod 644 ".$to."/*"
	);

	// TODO: cron-weekly to renew certs? or hook in certbot (when certbot renews, run this again, only if old files matched to avoid overwrite custom certs of customer)

	foreach ($cmds as $cmd) {
		rootHelper::system(true, $cmd, $error);
		if ($error) return false;
	}
	return true;
}

function setTxt($txt, $bc, $ba, $cloudaddr, &$ret) {
	// set txt record via sbcapi
	require_once('/usr/php/include/CloudSbcApi.php');

	$cloud 	  = new CloudSbcApi($bc, $ba, ['addr' => $cloudaddr]);
	$response = $cloud->send('addTxt', ['txtdata' => $txt], ['asJSON' => true]);
	if (preg_match('/^txt record set$/', $response, $matched)) {
		if (strlen($matched[1]) > 0) {
			return true;
		}
	}
	$ret = $response;
	return false;
}

function setCertificates($files, &$error, &$fqdn, $dir = "/tmp/certificates") {
	$list = array();
	$ret = NULL;

	// make sure dir exists
	!is_dir($dir) && mkdir($dir);

	foreach ( $files as $name => $file ) {
		$path = $dir . "/" . ltrim($name,'uploadfile_') . ".pem";
		if ( 0 < $file['error'] || $file['size'] > 20000 ) {
			// each file should be there and not bigger than 20kb, tls certs are not that big usually
			$error = ltrim($name,'uploadfile_') . " invalid."; 
			return false;
		}
		if ( !move_uploaded_file( $file['tmp_name'], $path) ) {
			$error = "Error moving files to " . $dir;
			return false;
		}
		$list[] = array(
			ltrim($name,'uploadfile_') => $dir . "/" . ltrim($name,'uploadfile_') . ".pem"
		);
	}
	if ( !sizeof($list) == 3 || !validateCertificates($list) ) {
		$error = "Certificate could not be verified.";
		return false;
	}
	if ( !moveCertificates($dir,"/usr/conf/certs/wan", $ret) ) {
		$error = "Unable to install certificates: " . $ret;
		return false;
	}
	// get fqdn from certificate
	$fqdn = getCertificateSubject($list['cert']);

	// everything worked
	return true;
}

### main ###
$cert_error = NULL;
$txt_error = NULL;

switch ( $teams_cert ) {
	case "cert_bero":
		$fqdn 		= $sbcConf['DOMAIN_NAME'];
		$cloudaddr 	= $sbcConf['BEROCLOUD_ADDRESS'];

		$txt = $_POST['teams_txt_value'];
		$ret = "";
		//install certs
		if ( !moveCertificates("/etc/letsencrypt/live/". $fqdn, "/usr/conf/certs/wan", $ret) ) {
			$cert_error = "Unable to install certificates: ". $ret;
			break;
		}
		// send TXT Record to berocloud
		if ( !setTxt($txt, $bc, $ba, $cloudaddr, $ret) ) {
			$txt_error = "Unable to set TXT record! ". $ret;
		}

		$bc->set('root', 'teams_fqdn', sqlite_escape_string($fqdn));
		break;
	case "cert_custom":
		if ( empty($_FILES) ) {
			$cert_error = "Missing files";
			break;
		}
		if ( !setCertificates($_FILES, $cert_error, $fqdn) ) {
			//function sets cert_error on fail
			break;
		}

		$bc->set('root', 'teams_fqdn', sqlite_escape_string($fqdn));
		break;
	case "cert_skip":
		//only create SIP config, use saved fqdn
		if ( empty($fqdn) ) {
			$cert_error = "Skipping not possible because no certificate was configured before!";
		}
		break;
	default:
		$cert_error = "Method unknown. Please choose beroNet certificate or use your own!";
		break;
}

if ( is_null($cert_error) ) {
	// ### create SIP Account ### TODO: rework to not give every single value
	$sip_query = $ba->insert_(
		"INSERT INTO sip (name, sip_proxy, sip_registrar, sip_domain, user, secret, register, def, config , stunserver, externip , regrefresh, register_option, auth_user, displayname, sip_transport, matchtype, matchtype_manual, profile, enum_support, enum_search_domain, keepalive_interval, call_transfer_method, sip_custom_port, sip_stack, validation, regrefresh_on_validation_fail, callgroup_name, callgroup_priority, max_simultaneous_calls, dns_change_registration_behaviour, dns_change_minimum_registration_time) "
	.	"VALUES ('".sqlite_escape_string($name)."','sip.pstnhub.microsoft.com','sip.pstnhub.microsoft.com:5061','sip.pstnhub.microsoft.com','".sqlite_escape_string($fqdn)."','','0',0,'t38=0,ie_on_sip=0,wait_for_cancel=0,dtmfmode=rfc2833,failover_timeout=0,isdn2sip_destination_numformat=VAZ_PLUS,isdn2sip_source_numformat=VAZ_PLUS,dialplan_international_prefix=00,sip2dialplan_dad_prefix_setting=replace,sip2dialplan_oad_prefix_setting=replace,srtp_mode=mandatory,s2s_nat_opener=0,use_privacy_header=auto,qvalue=-1,dnssrv=0,tr_notruf=0,s2s_rtp_handling_method=0,sips_on_tls=0,1tr119=0,srtp_crypto_suites=AES_CM_128_HMAC_SHA1_80:AES_CM_128_HMAC_SHA1_32:F8_128_HMAC_SHA1_80,codecs=pcma,sip_to_user_setting=\${new_destination},sip_from_user_setting=\${new_source},sip_pai_user_setting=\${new_source},sip_contact_user_setting=\${account_username},from_sip_src_setting=auto,from_sip_dest_setting=auto,sip_contact_all_setting=<sip:".sqlite_escape_string($fqdn)."\;transport=tls>','','".sqlite_escape_string($pub_ip)."',300,'validate options-keepalive','','','tls','address',NULL,'manual',0,'',30,'refer','','wan','1','0','','','','change_when_no_calls','900');");

	// set paired value to sRTP

	// ### create Dialplan Rules ### TODO: rework to not give every single value
	$id_query = $ba->select("SELECT * FROM sip WHERE id = '$paired_id'");
	$id_entry = $ba->fetch_array($id_query);

	$dp_query = $ba->insert_(
		"INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, config, isdnid, posId, comment, activ) "
	. 	"VALUES ('sip','sip','a:".sqlite_escape_string($id_entry['name'])."','p:".sqlite_escape_string($name)."','(.*)','\\1','(.*)','\\1','sip_contact_all_setting=<sip:\${new_source}@".sqlite_escape_string($fqdn).";transport=tls>,sip_to_user_all_setting=<sip:\${new_destination}@".sqlite_escape_string($fqdn).">,sip_from_user_all_setting=<sip:\${new_source}@".sqlite_escape_string($fqdn).";transport=tls>,sip_request_uri_all_setting=INVITE sip:\${new_destination}@sip.pstnhub.microsoft.com SIP/2.0','',1,'',1)");
	$dp_query2 = $ba->insert_(
		"INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, config, isdnid, posId, comment, activ) "
	. 	"VALUES ('sip','sip','p:".sqlite_escape_string($name)."','p:".sqlite_escape_string($id_entry['name'])."','(.*)','\\1','(.*)','\\1','','',2,'',1)");

	Helper::activate(1);

	if (!$ba->is_error()) {
		$response['message'] = "Successfully created!";
		$response['status']  = 'success';
		if ( !is_null($txt_error) )
			$response['txt_error'] = $txt_error;
	} else {
		$response['message'] = $ba->error();
		$response['status']  = 'error';
	}
} else {
	$response['message'] = $cert_error;
	$response['status']  = 'error';
}

echo json_encode($response);